package com.ruoyi.tc.entity.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @author dong
 * @since 2024/11/19 10:27
 */
@Data
@ApiModel("任务主表分页请求类")
public class AssetTaskPageRequest {


    /**
     * 主键id
     */
    @ApiModelProperty("主键id")
    private Integer id;
    /**
     * 任务名称
     */
    @ApiModelProperty("任务名称")
    private String taskName;


    /**
     * 任务编号
     */
    @ApiModelProperty("任务编号")
    private String taskId;


    /**
     * 任务状态1：进行中，2：正常完成，3：超期完成，4：正常完成，5：审核驳回
     */
    @ApiModelProperty("任务状态1：进行中，2：正常完成，3：超期完成，4：正常完成，5：审核驳回")
    private String taskStatus;

    /**
     * 任务开始时间
     */
    @ApiModelProperty("任务开始时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime begainTime;


    /**
     * 任务结束时间
     */
    @ApiModelProperty("任务结束时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime endTime;


    /**
     * 单位名称
     */
    @ApiModelProperty("单位名称")
    private String dwmc;
}
